BIO_F_BASE64(3)

NAME
BIO_f_base64 - base64 BIO filter

SYNOPSIS
#include <openssl/bio.h>
#include <openssl/evp.h>
BIO_METHOD *
BIO_f_base64(void);

DESCRIPTION
BIO_f_base64() returns the base64 BIO method. This is a filter BIO that base64 encodes any data written through it and decodes any data read through it.

Base64 BIOs do not support BIO_gets(3) or BIO_puts(3).

BIO_flush(3) on a base64 BIO that is being written through is used to signal that no more data is to be encoded: this is used to flush the final block through the BIO.

To encode the data all on one line and to expect the data to be all on one line, initialize the base64 BIO as follows:

    BIO *b64 = BIO_new(BIO_f_base64());
    BIO_set_flags(b64, BIO_FLAGS_BASE64_NO_NL);

RETURN VALUES
BIO_f_base64() returns the base64 BIO method.

EXAMPLES
Base64 encode the string "Hello World\n" and write the result to standard output:

    BIO *bio, *b64;
    char message[] = "Hello World \n";
    b64 = BIO_new(BIO_f_base64());
    bio = BIO_new_fp(stdout, BIO_NOCLOSE);
    BIO_push(b64, bio);
    BIO_write(b64, message, strlen(message));
    BIO_flush(b64);
    BIO_free_all(b64);

Read Base64-encoded data from standard input and write the decoded data to standard output:

    BIO *bio, *b64, *bio_out;
    char inbuf[512];
    int inlen;
    b64 = BIO_new(BIO_f_base64());
    bio = BIO_new_fp(stdin, BIO_NOCLOSE);
    bio_out = BIO_new_fp(stdout, BIO_NOCLOSE);
    BIO_push(b64, bio);
    while((inlen = BIO_read(b64, inbuf, 512)) > 0)
    	BIO_write(bio_out, inbuf, inlen);
    BIO_flush(bio_out);
    BIO_free_all(b64);

SEE ALSO
BIO_new(3)

BUGS
The ambiguity of EOF in base64-encoded data can cause additional data following the base64-encoded block to be misinterpreted.

There should be some way of specifying a test that the BIO can perform to reliably determine EOF (for example a MIME boundary).